com.ibm.openpages.api.configuration

## Interface IConfigurationFactory

-     public interface IConfigurationFactory

  Interface that creates instances of interfaces in package com.ibm.openpages.api.configuration in OpenPages with Watson.

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `IDashboardPanel` | `createDashboardPanel(IDashboardPanel.DashboardPanelType type, java.lang.String name)` Creates an on-memory instance of dashboard panel
    `IDashboardTab` | `createDashboardTab(IDashboardTab.DashboardTabType type, java.lang.String name)` Creates an on-memory instance of dashboard tab
    `IDashboardView` | `createDashboardView(Id profileId, java.lang.String name)` Creates an on-memory instance of dashboard view.
    `IDashboardWidget` | `createDashboardWidget(IDashboardWidget.DashboardWidgetType type, java.lang.String name)` Creates an on-memory instance of dashboard widget
    `IExchangeRate` | `createExchangeRate(IConfigurationService configService, ISOCurrencyCode isoCurrencyCode, double rate, java.util.Date startDate)` Creates an instance of IExchangeRate.
    `IExchangeRate` | `createExchangeRate(IConfigurationService configService, java.lang.String currencyCode, double rate, java.util.Date startDate)` Creates an instance of IExchangeRate.
    `IExchangeRate` | `createExchangeRate(ICurrency currency, double rate, java.util.Date startDate)` Creates an instance of IExchangeRate.
    `IFindGroupCondition` | `createFindGroupCondition(IFindGroupCondition.LogicalOp logicalOperator)` Creates an on-memory instance of group condition for the find option
    `IFindInCondition` | `createFindInCondition(java.lang.String attribute, boolean invertMatch)` Creates an on-memory instance of in-condition for the find option
    `IFindOptions` | `createFindOptions()` Creates an on-memory instance of find option
    `IFindSimpleCondition` | `createFindSimpleCondition(java.lang.String attribute, IFindSimpleCondition.RelationalOp relationalOperator, boolean invertMatch, java.lang.String value)` Creates an on-memory instance of simple condition for the find option
    `ILabel` | `createLabel(java.util.Locale locale, java.lang.String value)` Creates an on-memory instance of label
    `IRespView` | `createRespView(ITypeDefinition typeDefinition, RespViewType viewType, java.lang.String viewName)` Creates an on-memory instance of responsive view
    `IRespViewAction` | `createRespViewAction(java.lang.String name, RespViewActionType actionType)` Creates an on-memory instance of responsive view action
    `IRespViewField` | `createRespViewField(RespViewFieldType type, IFieldDefinition objectFieldDef, ITypeDefinition relationObjectDef, java.lang.String fieldName)` Creates an on-memory instance of responsive view field
    `IRespViewFieldRule` | `createRespViewFieldRule(java.lang.String type, java.lang.String condition, java.lang.String controllerName, java.util.List<IRespViewFieldRuleController> controllers)` Creates an on-memory instance of a rule definition on a responsive view field.
    `IRespViewFieldRuleController` | `createRespViewFieldRuleController(java.lang.String name, java.lang.Object values)` Creates an on-memory instance of a rule controller for a rule on a responsive view field.
    `IRespViewRuleCondition` | `createRespViewRuleCondition(RespViewRuleConditionType type, ITypeDefinition typeDefinition, IFieldDefinition fieldDefinition)` Creates an on-memory instance of view identification rule condition
    `IRespViewSection` | `createRespViewSection(java.lang.String sectionName)` Creates an on-memory instance of responsive view section

- - ### Method Detail

    - #### createExchangeRate

          IExchangeRate createExchangeRate(IConfigurationService configService,
                                           java.lang.String currencyCode,
                                           double rate,
                                           java.util.Date startDate)

      Creates an instance of IExchangeRate.
      Parameters:
        `configService` - the configuration service object
        `currencyCode` - the currency code, for example: "CAD", "JPY", etc.
        `rate` - the exchange rate
        `startDate` - the start date
      Returns:
        the instance of IExchangeRate

    - #### createExchangeRate

          IExchangeRate createExchangeRate(IConfigurationService configService,
                                           ISOCurrencyCode isoCurrencyCode,
                                           double rate,
                                           java.util.Date startDate)

      Creates an instance of IExchangeRate.
      Parameters:
        `configService` - the configuration service object
        `isoCurrencyCode` - the ISO currency code
        `rate` - the exchange rate
        `startDate` - the start date
      Returns:
        the instance of IExchangeRate

    - #### createExchangeRate

          IExchangeRate createExchangeRate(ICurrency currency,
                                           double rate,
                                           java.util.Date startDate)

      Creates an instance of IExchangeRate.
      Parameters:
        `currency` - the currency
        `rate` - the exchange rate
        `startDate` - the start date
      Returns:
        the instance of IExchangeRate

    - #### createRespView

          IRespView createRespView(ITypeDefinition typeDefinition,
                                   RespViewType viewType,
                                   java.lang.String viewName)

      Creates an on-memory instance of responsive view
      Parameters:
        `typeDefinition` - the type definition which the responsive view belongs to.
        `viewType` - the type of the responsive view.
        `viewName` - the immutable name of the responsive view.
      Returns:
        the instance of responsive view

    - #### createRespViewSection

          IRespViewSection createRespViewSection(java.lang.String sectionName)

      Creates an on-memory instance of responsive view section
      Parameters:
        `sectionName` - the immutable name of the section
      Returns:
        the instance of responsive view section

    - #### createRespViewField

          IRespViewField createRespViewField(RespViewFieldType type,
                                             IFieldDefinition objectFieldDef,
                                             ITypeDefinition relationObjectDef,
                                             java.lang.String fieldName)

      Creates an on-memory instance of responsive view field
      Parameters:
        `type` - the type of the responsive view field
        `objectFieldDef` - the field definition of the responsive view field when the type is `RespViewFieldType.object`
        `relationObjectDef` - the type definition of the responsive view field when `RespViewFieldType.isRelationship()` is true
        `fieldName` - the name of the responsive view field when `RespViewFieldType.isRelationship()` is true, when the type is `RespViewFieldType.help`, or when the type is `RespViewFieldType.group`
      Returns:

    - #### createLabel

          ILabel createLabel(java.util.Locale locale,
                             java.lang.String value)

      Creates an on-memory instance of label
      Parameters:
        `locale` - the locale of the label
        `value` - the localized value for the locale
      Returns:
        the instance of label

    - #### createRespViewAction

          IRespViewAction createRespViewAction(java.lang.String name,
                                               RespViewActionType actionType)

      Creates an on-memory instance of responsive view action
      Parameters:
        `name` -
        `actionType` -
      Returns:
        the instance of responsive view action

    - #### createRespViewRuleCondition

          IRespViewRuleCondition createRespViewRuleCondition(RespViewRuleConditionType type,
                                                             ITypeDefinition typeDefinition,
                                                             IFieldDefinition fieldDefinition)

      Creates an on-memory instance of view identification rule condition
      Parameters:
        `type` - - the type of the condition
        `typeDefinition` - - `ITypeDefinition` to apply the condition to
        `fieldDefinition` - - `IFieldDefinition` to apply the condition to when the type's `RespViewRuleConditionType.isFieldCondition()` is true
      Returns:
        the instance of view identification rule condition

    - #### createRespViewFieldRule

          IRespViewFieldRule createRespViewFieldRule(java.lang.String type,
                                                     java.lang.String condition,
                                                     java.lang.String controllerName,
                                                     java.util.List<IRespViewFieldRuleController> controllers)

      Creates an on-memory instance of a rule definition on a responsive view field.
      Parameters:
        `type` - - the type of the dependency (e.g., "visible", "required", "equal")
        `condition` - - the condition (e.g., "allOf", "anyOf")
        `controllerName` - - the name of the controller field (e.g., "OPSS-Ctl:Operating Effectiveness")
        `controllers` - - `IRespViewFieldRuleController` the list of controllers for the dependency
      Returns:
        IRespViewDependency

    - #### createRespViewFieldRuleController

          IRespViewFieldRuleController createRespViewFieldRuleController(java.lang.String name,
                                                                         java.lang.Object values)

      Creates an on-memory instance of a rule controller for a rule on a responsive view field.
      Parameters:
        `name` - - the name of the controller field (e.g., "OPSS-Ctl:Operating Effectiveness")
        `values` - - the values for which this dependency will evaluate to true. Can be Boolean or List
      Returns:
        IRespViewDependencyController

    - #### createDashboardView

          IDashboardView createDashboardView(Id profileId,
                                             java.lang.String name)

      Creates an on-memory instance of dashboard view.
      Parameters:
        `profileId` - - The object profile Id to associate to.
        `name` - - The name of the dashboard view.
      Returns:
      Since:
        8.1

    - #### createDashboardTab

          IDashboardTab createDashboardTab(IDashboardTab.DashboardTabType type,
                                           java.lang.String name)

      Creates an on-memory instance of dashboard tab
      Parameters:
        `type` - - The type of the dashboard tab
        `name` - - The name of the dashboard tab
      Returns:
      Since:
        8.1

    - #### createDashboardPanel

          IDashboardPanel createDashboardPanel(IDashboardPanel.DashboardPanelType type,
                                               java.lang.String name)

      Creates an on-memory instance of dashboard panel
      Parameters:
        `type` - - The type of the dashboard panel
        `name` - - The name of the dashboard panel
      Returns:
      Since:
        8.1

    - #### createDashboardWidget

          IDashboardWidget createDashboardWidget(IDashboardWidget.DashboardWidgetType type,
                                                 java.lang.String name)

      Creates an on-memory instance of dashboard widget
      Parameters:
        `type` - - The type of the dashboard widget
        `name` - - The name of the dashboard widget
      Returns:
      Since:
        8.1

    - #### createFindOptions

          IFindOptions createFindOptions()

      Creates an on-memory instance of find option
      Returns:
      Since:
        8.1

    - #### createFindGroupCondition

          IFindGroupCondition createFindGroupCondition(IFindGroupCondition.LogicalOp logicalOperator)

      Creates an on-memory instance of group condition for the find option
      Parameters:
        `logicalOperator` -
      Returns:
      Since:
        8.1

    - #### createFindSimpleCondition

          IFindSimpleCondition createFindSimpleCondition(java.lang.String attribute,
                                                         IFindSimpleCondition.RelationalOp relationalOperator,
                                                         boolean invertMatch,
                                                         java.lang.String value)

      Creates an on-memory instance of simple condition for the find option
      Parameters:
        `attribute` - - The attribute for the condition
        `relationalOperator` - - The relational operator
        `invertMatch` - - Flag to invert the condition
        `value` - - The value to match
      Returns:
      Since:
        8.1

    - #### createFindInCondition

          IFindInCondition createFindInCondition(java.lang.String attribute,
                                                 boolean invertMatch)

      Creates an on-memory instance of in-condition for the find option
      Parameters:
        `attribute` - - The attribute for the condition
        `invertMatch` - - Flag to invert the condition
      Returns:
      Since:
        8.1

Licensed Materials - Property of IBM
OpenPages with Watson (PID: 5725-D51)
© Copyright IBM Corporation 2013, 2022. All Rights Reserved.
US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.